#ifndef _KILIB_WND_H
#define _KILIB_WND_H
namespace kilib{


#define IDTIMEOUT 0


//-------------------------------------------------------------------------
//@{
//	EChENX
//
//	ڂ͗p܂B
//	Cup҂h肵ĎgƂ܂B
//	Window, Dlg Ȃǂ̋ۃNX̕p邱ƂɂȂ܂B
//
//	Wnd璼ڔhȂA
//	preCreate(), detachHwnd(), isDlgMsg() K؂ɈƁB
//
//	ƁA}`Xbhœɓȏ㑋ƃołB
//	ȂȂƂ́AʑwŔrƂĉB
//@}
//-------------------------------------------------------------------------

class Wnd
{
public:

  //# attr_get

	//@{
	//	HWND擾
	//@}
	HWND  hwnd() const;

	//@{
	//	݂Ă鑋ۂ
	//@}
	bool alive() const;

  //# operation

	//@{
	//	bZ[W𑗂ď܂őҋ@
	//	@param msg 肽bZ[W
	//	@param wp msgɂ
	//	@param lp msgɂ
	//	@return msgɂ
	//@}
	LRESULT SendMsg( UINT msg, WPARAM wp=0, LPARAM lp=0 );

	//@{
	//	bZ[W𑗂ĂA
	//	@param msg 肽bZ[W
	//	@param wp msgɂ
	//	@param lp msgɂ
	//	@return msgɂ
	//@}
	BOOL    PostMsg( UINT msg, WPARAM wp=0, LPARAM lp=0 );

	//@{
	//	ŋ@\tbZ[W{bNX
	//	@param msg \镶
	//	@param caption _CAȎ薼
	//	@param type Win32SDK̐Ă
	//	@param timeout \ԁB-1Ɓ
	//@}
	int     MsgBox( LPCTSTR msg, LPCTSTR caption=NULL, UINT type=MB_OK, int timeout=-1 ) const;

	//@{
	//	CbZ[W[v
	//@}
	void    MsgLoop();

	//@{
	//	EChE\
	//@}
	void    ShowUp();

  //# static_operation

	//@{
	//	őOʂɎĂ
	//	@param hwnd EChE
	//@}
	static void SetFront( HWND hwnd );

	//@{
	//	ʒɔzu
	//	@param hwnd EChE
	//	@param rel ɂEChE
	//@}
	static void SetCenter( HWND hwnd, HWND rel=NULL );

	//@{
	//	L[ɗ܂Ă郁bZ[WS
	//@}
	static void ProcessMsg();

	//@{
	//	HWNDWnd*ϊ
	//@}
	static Wnd* wndptr( HWND hwnd );

protected:

  //# interface

	//@{
	//	΁AhNXŃI[o[Ch
	//	ANZ[^e[uʂ
	//@}
	private: virtual bool TrnsAccel( MSG* msg );

private:

  //# field

 	mutable HWND m_hWnd;
	static HHOOK s_hHook;
	static Wnd*  s_pCurInit;

 //# method_for_insider

	public:    static void InitWndLib();
	           static void FinishWndLib();
	protected: static Wnd* wndptr_direct( HWND hwnd );
	           static void PreCreate( Wnd* wnd );
	                  void DetachHwnd();
	private:   virtual bool IsDlgMsg( MSG* msg ) = 0;
	protected: Wnd();
	public:    virtual ~Wnd();
	           static int MsgBoxCoreRoutine( HWND wnd, LPCTSTR msg, LPCTSTR caption, UINT type, int timeout );
	private:   static LRESULT CALLBACK CBTProc( int code, WPARAM wp, LPARAM lp );
};


//-------------------------------------------------------------------------
//@{
//	ʂ̑
//
//	OWndƃN\킵łƂA
//	CreateWindowō镁ʂ̑܂B
//	RXgN^ɂāAWNDCLASSStyle͌Œ肵܂̂ŁA
//	PނWindowɂPނclass WindowhNXKvłB
//
//	̃NXňWNDCLASŚAKilibRegisterClass()œo^邱ƁI
//@}
//-------------------------------------------------------------------------


class Window : public Wnd
{
public:

  //# init

	//@{
	//	EChE쐬
	//@}
	bool Create( LPCTSTR wndName, int x=CW_USEDEFAULT, int y=CW_USEDEFAULT, int width=CW_USEDEFAULT, int height=CW_USEDEFAULT, HWND parent=NULL );

protected:

  //# method_for_children

	//@{
	//	RXgN^
	//	@param className EChENX
	//	@param style WX^C
	//	@param styleEx WgX^C
	//@}
	Window( LPCTSTR className, DWORD style, DWORD styleEx=0 );

  //# interface

	// ĂƁ[ɎĔĂB
	// on_command́AȂtrueԂƁB
	// on_messagéAȂreturn Window::on_message(...)邱ƁB
	virtual void    on_init();
	virtual void    on_destroy();
	virtual bool    on_command( UINT id, HWND ctrl );
	virtual LRESULT on_message( UINT msg, WPARAM wp, LPARAM lp );

private:

  //# field

	LPCTSTR     m_className;
	const DWORD m_style, m_styleEx;

  //# method_for_insider

	public:  static ATOM MyRegisterClassEx( WNDCLASSEX* cls );
	private: static LRESULT CALLBACK CommonProc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp );
	         bool   IsDlgMsg( MSG* msg );
};


#define KilibRegisterClass(_cls) (kilib::Window::MyRegisterClassEx(_cls))


//-------------------------------------------------------------------------
//@{
//	_CAO
//
//	hNXāARXgN^Ń\[XIDnĉB
//@}
//-------------------------------------------------------------------------


class Dlg : public Wnd
{
public:
	enum dlgtype { MODAL, MODELESS };

  //# init

	//@{
	//	[_Ŏs
	//	@param parent eEChE
	//@}
	virtual void GoModal   ( HWND parent=NULL );

	//@{
	//	[hXō쐬
	//	@param parent eEChE
	//@}
	virtual void GoModeless( HWND parent=NULL );

  //# final

	//@{
	//	IɏI点
	//	@param code IR[h
	//@}
	virtual void End( UINT code );

  //# attr_get

	//@{
	//	[_[hX
	//@}
	dlgtype  type() const;

	//@{
	//	IR[h擾
	//@}
	UINT  endcode() const;

protected:

  //# interface

	// ĂƁ[ɎĔĂB
	// on_ok/on_canceĺAIėǂȂtrueԂƁB
	// on_cmd/on_msǵAς݂ȂtrueԂƁB
	virtual void on_init();
	virtual void on_destroy();
	virtual bool on_ok();
	virtual bool on_cancel();
	virtual bool on_command( UINT cmd, UINT id, HWND ctrl );
	virtual bool on_message( UINT msg, WPARAM wp, LPARAM lp );

  //# method_for_children

	//@{
	//	RXgN^
	//	@param id _CAO\[XID
	//@}
	Dlg( UINT id );

	//@{
	//	qACeIDHWNDϊ
	//@}
	HWND item( UINT id );

	//@{
	//	ACeɑ΂ăbZ[WM
	//@}
	LRESULT SendMsgToItem( UINT id, UINT msg, WPARAM wp=0, LPARAM lp=0 );

private:

  //# field

	dlgtype    m_fType;
	UINT       m_EndCode;
	const UINT m_Rsrc;

  //# method_for_insider

	protected: void SetEndCode( UINT endcode );
	           void SetType( dlgtype tp );
	           UINT rsrcID() const;
	private:   bool IsDlgMsg( MSG* msg );
	           static BOOL CALLBACK CommonProc( HWND dlg, UINT msg, WPARAM wp, LPARAM lp );
};


//-------------------------------------------------------------------------


};     // namespace kilib
#endif // _KILIB_WND_H
